# coding: utf-8

"""
    Groupe PSA Connected Car - WEB API B2C

    *PSA B2C Connected Car API*  # Introduction This is the description of the *Groupe PSA Connected Car V2 API*. The speccification is  is based on **OpenAPI Specification version 3** and can be displayed via [ReDoc](https://github.com/Rebilly/ReDoc)a or [Swagger](http://swagger.io).   This API allows applications to fetch data from the connected Vehicles data platform. # Authentication PSA Connected Car APIs uses the [OAuth 2.0](https://tools.ietf.org/html/rfc6749) protocol for authentication and Authorization. any application require a valid [Access Token](https://tools.ietf.org/html/rfc6749#section-1.4) to access to user data. # Errors   Error codes returned by all REST APIs comply with the standard. Nevertheless, PSA Services (callers) need to have more complete data structures (even when the answer is not Http-OK) to better detail the type of error by providing application code, message and a debugging code(for investigation purposes). The http code of the response is managed by the protocol itself (in the header).      **Errors are  returned as a generic error response:**    * ```xError``` object model.       # noqa: E501

    OpenAPI spec version: 4.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class MonitorSubscribe(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'batch_notify': 'MonitorSubscribeBatchNotify',
        'callback': 'MonitorWebhook',
        'refresh_event': 'float',
        'retry_policy': 'MonitorSubscribeRetryPolicy'
    }

    attribute_map = {
        'batch_notify': 'batchNotify',
        'callback': 'callback',
        'refresh_event': 'refreshEvent',
        'retry_policy': 'retryPolicy'
    }

    def __init__(self, batch_notify=None, callback=None, refresh_event=None, retry_policy=None):  # noqa: E501
        """MonitorSubscribe - a model defined in Swagger"""  # noqa: E501

        self._batch_notify = None
        self._callback = None
        self._refresh_event = None
        self._retry_policy = None
        self.discriminator = None

        if batch_notify is not None:
            self.batch_notify = batch_notify
        self.callback = callback
        if refresh_event is not None:
            self.refresh_event = refresh_event
        if retry_policy is not None:
            self.retry_policy = retry_policy

    @property
    def batch_notify(self):
        """Gets the batch_notify of this MonitorSubscribe.  # noqa: E501


        :return: The batch_notify of this MonitorSubscribe.  # noqa: E501
        :rtype: MonitorSubscribeBatchNotify
        """
        return self._batch_notify

    @batch_notify.setter
    def batch_notify(self, batch_notify):
        """Sets the batch_notify of this MonitorSubscribe.


        :param batch_notify: The batch_notify of this MonitorSubscribe.  # noqa: E501
        :type: MonitorSubscribeBatchNotify
        """

        self._batch_notify = batch_notify

    @property
    def callback(self):
        """Gets the callback of this MonitorSubscribe.  # noqa: E501


        :return: The callback of this MonitorSubscribe.  # noqa: E501
        :rtype: MonitorWebhook
        """
        return self._callback

    @callback.setter
    def callback(self, callback):
        """Sets the callback of this MonitorSubscribe.


        :param callback: The callback of this MonitorSubscribe.  # noqa: E501
        :type: MonitorWebhook
        """
        if callback is None:
            raise ValueError("Invalid value for `callback`, must not be `None`")  # noqa: E501

        self._callback = callback

    @property
    def refresh_event(self):
        """Gets the refresh_event of this MonitorSubscribe.  # noqa: E501

        Define the period (in sec.) between two refresh events. The refresh-events are sent when the condition of the monitor is satisfied (Trigger -> toggled true).A kind of periodic reminder.  # noqa: E501

        :return: The refresh_event of this MonitorSubscribe.  # noqa: E501
        :rtype: float
        """
        return self._refresh_event

    @refresh_event.setter
    def refresh_event(self, refresh_event):
        """Sets the refresh_event of this MonitorSubscribe.

        Define the period (in sec.) between two refresh events. The refresh-events are sent when the condition of the monitor is satisfied (Trigger -> toggled true).A kind of periodic reminder.  # noqa: E501

        :param refresh_event: The refresh_event of this MonitorSubscribe.  # noqa: E501
        :type: float
        """
        if refresh_event is not None and refresh_event < 60:  # noqa: E501
            raise ValueError("Invalid value for `refresh_event`, must be a value greater than or equal to `60`")  # noqa: E501

        self._refresh_event = refresh_event

    @property
    def retry_policy(self):
        """Gets the retry_policy of this MonitorSubscribe.  # noqa: E501


        :return: The retry_policy of this MonitorSubscribe.  # noqa: E501
        :rtype: MonitorSubscribeRetryPolicy
        """
        return self._retry_policy

    @retry_policy.setter
    def retry_policy(self, retry_policy):
        """Sets the retry_policy of this MonitorSubscribe.


        :param retry_policy: The retry_policy of this MonitorSubscribe.  # noqa: E501
        :type: MonitorSubscribeRetryPolicy
        """

        self._retry_policy = retry_policy

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(MonitorSubscribe, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MonitorSubscribe):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
